<?php
// osCommerce Product Manager for Windows (oscpmwin).
// Copyright 2003,2004 by Mario A. Valdez-Ramirez.

// You can contact Mario A. Valdez-Ramirez
// by email at mario@mariovaldez.org or paper mail at
// Olmos 809, San Nicolas, NL. 66495, Mexico.

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


// ==================================
// Start of configuration options...
// ==================================

$opm_jpeg_truecolors = true;
$opm_images_directory = "images/";
$opm_enable_logfile = false;
$opm_debug_file = "debug.txt";
$opm_browser_debug = false;

// ==================================
// End of configuration options...
// ==================================

$opm_script_version = "0.1.2";


$opm_realpath = str_replace (basename (__FILE__), "", __FILE__) . $opm_images_directory;
if (!$opm_browser_debug) {
  $opm_password = trim ($_POST["Pw"]);
  $opm_operation = trim ($_POST["Op"]);
  $opm_filename = str_replace (" ", "_", str_replace ("..", "", str_replace ("\\", "", str_replace ("//", "/", trim ($_POST["Fn"])))));
  $opm_subdir = str_replace (" ", "_", str_replace ("..", "", str_replace ("\\", "", str_replace ("//", "/", trim ($_POST["SD"])))));
  $opm_smartrename = abs (trim ($_POST["SR"]));
  $opm_reqversion = trim ($_POST["Vn"]);
}
else {
  $opm_password = trim ($_GET["Pw"]);
  $opm_operation = trim ($_GET["Op"]);
  $opm_filename = str_replace (" ", "_", str_replace ("..", "", str_replace ("\\", "", str_replace ("//", "/", trim ($_GET["Fn"])))));
  $opm_subdir = str_replace (" ", "_", str_replace ("..", "", str_replace ("\\", "", str_replace ("//", "/", trim ($_GET["SD"])))));
  $opm_smartrename = abs (trim ($_GET["SR"]));
  $opm_reqversion = trim ($_GET["Vn"]);
}
if (($opm_filename{0} == "/") || ($opm_filename{0} == ".")) {
  $opm_filename = substr ($opm_filename, 1, strlen ($opm_filename) - 1);
}


if ($opm_smartrename > 0) {
  $opm_smartrename = 1;
}
else {
  $opm_smartrename = 0;
}


if (!$opm_browser_debug) {
  opm_FNDebug_Log (print_r ($_POST, true));
}
else {
  opm_FNDebug_Log (print_r ($_GET, true));
}
opm_FNDebug_Log ("REALPATH=" . $opm_realpath);
opm_FNDebug_Log ("PASSWORD=" . $opm_password);
opm_FNDebug_Log ("OPERATION=" . $opm_operation);
opm_FNDebug_Log ("FILENAME=" . $opm_filename);
opm_FNDebug_Log ("SUBDIR=" . $opm_subdir);
opm_FNDebug_Log ("SMARTRENAME=" . $opm_smartrename);
opm_FNDebug_Log ("REQVERSION=" . $opm_reqversion);



if ($opm_browser_debug) { echo "<pre>"; }



if (($opm_script_version != $opm_reqversion) && ($opm_operation)) {
  echo "ERROR WRONG SCRIPT VERSION";
  return;
}
// ==================================
// CHECK if a file exists.
// CHECK requires the full path of the image.
// ==================================
if ($opm_operation == 'check') {
  if ($opm_filename) {
    if (file_exists ($opm_realpath . $opm_filename)) {
      echo "OK FILE EXISTS";
      return;
    }
    else {
      echo "ERROR FILE NOT FOUND";
      return;
    }
  }
}
// ==================================
// LIST all files recursively.
// LIST returns the filenames with paths.
// ==================================
if ($opm_operation == 'list') {
  echo "OK LIST START\n";
  opm_FNList_Files ($opm_realpath, "", false);
  echo "OK LIST END\n";
  return;
}
// ==================================
// LISTDIRS only dirs recursively.
// LISTDIRS returns no filenames.
// ==================================
if ($opm_operation == 'listdirs') {
  echo "OK LISTDIRS START\n";
  opm_FNList_Files ($opm_realpath, "", true);
  echo "OK LISTDIRS END\n";
  return;
}
// ==================================
// DELETE an image.
// DELETE requires the filename of the image with path.
// ==================================
if ($opm_operation == 'delete') {
  if ($opm_filename) {
    if (file_exists ($opm_realpath . $opm_filename)) {
      if (@unlink ($opm_realpath . $opm_filename)) {
        if (!file_exists ($opm_realpath . $opm_filename)) {
          echo "OK DELETE";
          return;
        }
        else {
          echo "ERROR DELETE FILE REMAINS";
          return;
        }
      }
      else {
        echo "ERROR DELETE UNKNOWN";
        return;
      }
    }
    else {
      echo "OK DELETE FILE NOT FOUND";
      return;
    }
  }
}
// ==================================
// UPLOAD an image.
// UPLOAD requires the path, without filename, where the image will be stored.
// UPLOAD returns the image filename with the path.
// ==================================
if ($opm_operation == 'upload') {
  if ($_FILES["Fl"]["name"] && $_FILES["Fl"]["size"]) {
    if (is_uploaded_file ($_FILES["Fl"]["tmp_name"])) {
      if ($opm_filename) {
        $newfn = $opm_filename;
      }
      else {
        $newfn = trim ($_FILES["Fl"]["name"]);
      }
      $newfn = str_replace (" ", "_", $newfn);
      $newfn = str_replace ("/", "", $newfn);
      $newfn = str_replace ("\\", "", $newfn);
      $newfn = ereg_replace("[^[:alnum:]\._]", "", $newfn);
      $newfn = strtolower ($newfn);

      if ($opm_subdir) {
        if ((!file_exists ($opm_realpath . $opm_subdir)) || (!is_dir ($opm_realpath . $opm_subdir))) {
          opm_FNDebug_Log ("will create directory=" . $opm_realpath . $opm_subdir);
          opm_FNmkdirs ($opm_realpath . $opm_subdir, 0777);
        }
        if (file_exists ($opm_realpath . $opm_subdir) && (is_dir ($opm_realpath . $opm_subdir))) {
          opm_FNDebug_Log ("directory exists=" . $opm_realpath . $opm_subdir);
          $newfn = $opm_subdir . "/" . $newfn;
        }
        else {
          opm_FNDebug_Log ("directory doesn't exist, will ignore=" . $opm_realpath . $opm_subdir);
        }

      }
      opm_FNDebug_Log ("wanted filename=" . $newfn);
      if ($opm_smartrename == 1) {
        $newfn = opm_FNSmart_Rename ($newfn, 100);
      }
      opm_FNDebug_Log ("smart filename=" . $newfn);
      opm_FNDebug_Log ("REALPATH=" . $opm_realpath);
      if (!file_exists ($opm_realpath . $newfn)) {
        opm_FNDebug_Log ("file not exist=" . $opm_realpath . $newfn);
        if (@move_uploaded_file ($_FILES["Fl"]["tmp_name"], $opm_realpath . $newfn)) {
          opm_FNDebug_Log ("moving file to=" . $opm_realpath . $newfn);
          if (file_exists ($opm_realpath . $newfn)) {
            opm_FNDebug_Log ("upload complete=" . $opm_realpath . $newfn);
            echo "OK UPLOAD [" . $newfn . "]";
            return;
          }
          else {
            opm_FNDebug_Log ("ERROR file not copied=" . $opm_realpath . $newfn);
            echo "ERROR UPLOAD FILE NOT FOUND";
            return;
          }
        }
        else {
          opm_FNDebug_Log ("ERROR file not copied=" . $opm_realpath . $newfn);
          echo "ERROR UPLOAD CANNOT MOVE";
          return;
        }
      }
      else {
        opm_FNDebug_Log ("ERROR file exist=" . $opm_realpath . $newfn);
        echo "ERROR UPLOAD EXIST [" . $newfn . "]";
        return;
      }
    }
    else {
      opm_FNDebug_Log ("ERROR cannot find uploaded file!");
      echo "ERROR UPLOAD";
      return;
    }
  }
}


// ==================================
// If no command is requested, just display the version.
// ==================================
echo "<p>OSCommerce Product Manager, server-side script " . $opm_script_version . ".</p>";
if ($opm_browser_debug) {
  echo "<p>BROWSER DEBUG MODE ENABLED!</p>";
}
if ($opm_enable_logfile) {
  echo "<p>LOGFILE ENABLED!</p>";
}
return;


// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function opm_FNList_Files ($dirname, $parentdir, $onlydirs) {
	$dirhandle = opendir ($dirname);
  while (($file = readdir ($dirhandle)) != false)
    $sorteddir[count ($sorteddir)] = $file;
	closedir ($dirhandle);
  natcasesort ($sorteddir);
  if (!$onlydirs) {
  	foreach ($sorteddir as $file) {
      if (($file != ".") && ($file != "..")) {
        if (!is_dir ($dirname . $file)) {
          if ($parentdir) {
            echo $parentdir . "/" . $file . "\n";
          }
          else {
            echo $file . "\n";
          }
        }
      }
    }
    foreach ($sorteddir as $file) {
      if (($file != ".") && ($file != "..")) {
        if (is_dir ($dirname . $file)) {
          if ($parentdir) {
            opm_FNList_Files ($dirname . $file . "/", $parentdir . "/" . $file, $onlydirs);
          }
          else {
            opm_FNList_Files ($dirname . $file . "/", $file, $onlydirs);
          }
        }
      }
    }
  }
  else {
    foreach ($sorteddir as $file) {
      if (($file != ".") && ($file != "..")) {
        if (is_dir ($dirname . $file)) {
          if ($parentdir) {
            echo $parentdir . "/" . $file . "\n";
            opm_FNList_Files ($dirname . $file . "/", $parentdir . "/" . $file, $onlydirs);
          }
          else {
            echo $file . "\n";
            opm_FNList_Files ($dirname . $file . "/", $file, $onlydirs);
          }
        }
      }
    }
  }
}



// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function opm_FNSmart_Rename ($wantedname, $tries) {
global $opm_realpath;
  $newname = $wantedname;
  $newext = '.' . array_pop (explode ('.', $wantedname));
  for ($trycounter = 1; $trycounter <= $tries; $trycounter++) {
    if (!file_exists ($opm_realpath . $newname)) {
      return ($newname);
    }
    else {
      $newdirname = dirname ($wantedname);
      if ($newdirname != ".") {
        $newname = dirname ($wantedname) . "/" . basename ($wantedname, $newext) . "_" . $trycounter . $newext;
      }
      else {
        $newname = basename ($wantedname, $newext) . "_" . $trycounter . $newext;
      }
    }
  }
  return ($wantedname);
}



// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function opm_FNDebug_Log ($logline) {
global $opm_enable_logfile, $opm_debug_file;
  if ($opm_enable_logfile) {
    if (!(file_exists ($opm_debug_file) && !is_writable ($opm_debug_file))) {
      $opm_timestamp = date("Y-m-d H:i:s", mktime(date("H")+SLOGIN_TIMEZONE_SHIFT,date("i"),date("s"),date("m"),date("d"),date("Y")));
      $opm_lfilef = @fopen ($opm_debug_file, 'a');
      if ($opm_lfilef) {
        @fwrite ($opm_lfilef, $opm_timestamp . ": " . $logline . "\n");
        @fclose ($opm_lfilef);
      }
    }
  }
}


// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Based on code posted on php.net by saint@corenova.com and bart@cdasites.com
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function opm_FNmkdirs ($dirname) {
  if (is_dir ($dirname) || empty ($dirname)) return 1;
  if (file_exists ($dirname) && !is_dir ($dirname)) return 0;
  if (opm_FNmkdirs (substr ($dirname, 0, strrpos ($dirname, '/')))) {
    if (!file_exists($dirname)) {
      return @mkdir ($dirname);
    }
  }
  return 0;
}

?>